#include "global.h"

#include "assets/ast_versus.h"
#include "assets/ast_arwing.h"
#include "assets/ast_corneria.h"
#include "assets/ast_meteo.h"
#include "assets/ast_bolse.h"
#include "assets/ast_training.h"
#include "assets/ast_sector_x.h"
#include "assets/ast_sector_y.h"
#include "assets/ast_sector_z.h"
#include "assets/ast_aquas.h"
#include "assets/ast_macbeth.h"
#include "assets/ast_venom_1.h"
#include "assets/ast_venom_2.h"
#include "assets/ast_titania.h"
#include "assets/ast_katina.h"
#include "assets/ast_fortuna.h"
#include "assets/ast_7_ti_1.h"
#include "assets/ast_andross.h"
#include "assets/ast_ve1_boss.h"
#include "assets/ast_area_6.h"
#include "assets/ast_zoness.h"

f32 gActor241Hitbox[] = {
    1.0f, 0.0f, 50.0f, 0.0f, 25.0f, 0.0f, 25.0f,
};
f32 gCubeHitbox100[] = {
    1.0f, 0.0f, 50.0f, 0.0f, 50.0f, 0.0f, 50.0f,
};
f32 gCubeHitbox150[] = {
    1.0f, 0.0f, 75.0f, 0.0f, 75.0f, 0.0f, 75.0f,
};
f32 gCubeHitbox200[] = {
    1.0f, 0.0f, 100.0f, 0.0f, 100.0f, 0.0f, 100.0f,
};
f32 gCubeHitbox300[] = {
    // unused
    1.0f, 0.0f, 150.0f, 0.0f, 150.0f, 0.0f, 150.0f,
};
f32 gCubeHitbox400[] = {
    1.0f, 0.0f, 200.0f, 0.0f, 200.0f, 0.0f, 200.0f,
};
f32 gItemRingCheckHitbox[] = {
    1.0f, -113.0f, 61.0f, 98.0f, 100.0f, 0.0f, 219.0f,
};
f32 gNoHitbox[] = {
    0.0f,
};
f32 gItemCheckpointHitbox[] = {
    1.0f, -40.0f, 40.0f, 0.0f, 180.0f, 0.0f, 180.0f,
};
f32 gItemSupplyRingHitbox[] = {
    1.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f, 120.0f,
};
f32 gMeteoWarpHitbox[] = {
    1.0f, -40.0f, 100.0f, 0.0f, 100.0f, 0.0f, 100.0f,
};
f32 gItemPathChangeHitbox[] = {
    1.0f, 0.0f, 100.0f, 0.0f, 1200.0f, 0.0f, 1200.0f,
};
f32 gItemLasersHitbox[] = {
    1.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f,
};
f32 gItemBombHitbox[] = {
    1.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f, 120.0f,
};
f32 gActor190_191Hitbox[] = {
    1.0f, 0.0f, 40.0f, 0.0f, 40.0f, 0.0f, 40.0f,
};
f32 gActor194Hitbox[] = {
    1.0f, 0.0f, 50.0f, 0.0f, 50.0f, 0.0f, 50.0f,
};
f32 gTeamHitbox[] = {
    1.0f, 0.0f, 40.0f, 0.0f, 40.0f, 0.0f, 40.0f,
};
f32 gActorAllRangeHItbox[] = {
    1.0f, 0.0f, 40.0f, 0.0f, 40.0f, 0.0f, 40.0f,
};
f32 gWarpZoneEvent94Hitbox[] = {
    1.0f, 0.0f, 140.0f, 0.0f, 170.0f, 0.0f, 140.0f,
};
f32 gWarpZoneEvent96Hitbox[] = {
    4.0f, 0.0f,   140.0f, -675.0f, 140.0f, 0.0f,   810.0f, 0.0f,   140.0f, 675.0f, 140.0f,  0.0f,   810.0f,
    0.0f, 140.0f, 0.0f,   810.0f,  675.0f, 140.0f, 0.0f,   140.0f, 0.0f,   810.0f, -675.0f, 140.0f,
};
f32 gWarpZoneEvent92Hitbox[] = {
    1.0f, 0.0f, 140.0f, 0.0f, 140.0f, 0.0f, 1800.0f,
};
f32 gWarpZoneEvent93Hitbox[] = {
    2.0f, 0.0f, 140.0f, 0.0f, 140.0f, 0.0f, 1800.0f, 1.0f, 141.0f, 1.0f, 1800.0f, 1.0f, 140.0f,
};

// clang-format off
ObjectInfo gObjectInfo[] = {
  /* OBJ_SCENERY_0,   */  {(void*)     D_CO_6015F00, 0, (ObjectFunc)          NULL,        D_CO_603E3E0,   800.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_1,   */  {(void*)     D_CO_602E9E0, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_2,   */  {(void*)     D_CO_601BEC0, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_3,   */  {(void*)     D_CO_602E7A0, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_4,   */  {(void*)     D_CO_60244A0, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_5,   */  {(void*)     D_CO_602E570, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_6,   */  {(void*)     D_CO_60132B0, 0, (ObjectFunc)          NULL,        D_CO_603DCA4,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_7,   */  {(void*)     D_CO_602E080, 0, (ObjectFunc)          NULL,        D_CO_603DD40,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_8,   */  {(void*)     D_CO_60164F0, 0, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_9,   */  {(void*)     D_CO_6014500, 0, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_10,  */  {(void*)     D_CO_602D5F0, 0, (ObjectFunc)          NULL,        D_CO_603DDF0,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_11,  */  {(void*)     D_CO_601A7D0, 0, (ObjectFunc)          NULL,        D_CO_603DE8C,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_12,  */  {(void*)     D_CO_6014B50, 0, (ObjectFunc)          NULL,        D_CO_603DEF4,   500.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_13,  */  {(void*)     D_CO_6016580, 0, (ObjectFunc)          NULL,        D_CO_603DF8C,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_14,  */  {(void*)     D_CO_601B560, 0, (ObjectFunc) func_enmy_80066EA8,        D_CO_603DFDC,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_15,  */  {(void*)     D_CO_60361F0, 0, (ObjectFunc) func_enmy_80066EA8,        D_CO_603E014,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_16,  */  {(void*)     D_CO_6018E80, 0, (ObjectFunc) func_enmy_80066EA8,        D_CO_603E030,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_17,  */  {(void*)     D_CO_6035F10, 0, (ObjectFunc) func_enmy_80066EA8,        D_CO_603E09C,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_18,  */  {(void*) Corneria_8018753C, 1, (ObjectFunc) Corneria_80187530,     D_CO_603E98C,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_19,  */  {(void*)     D_CO_60153B0, 0, (ObjectFunc)          NULL,        D_CO_603E118,   100.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_20,  */  {(void*)     D_CO_601F5A0, 0, (ObjectFunc)          NULL,        D_CO_603E14C,   500.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_21,  */  {(void*)     D_CO_60137B0, 0, (ObjectFunc)          NULL,        D_CO_603E1B4,   400.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_22,  */  {(void*)     D_CO_6006A80, 0, (ObjectFunc)          NULL,        D_CO_603E21C,   400.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_23,  */  {(void*)     D_CO_6016270, 0,    (ObjectFunc)          NULL,        D_CO_603E4A0,   200.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_24,  */  {(void*)     D_CO_6010E00, 0, (ObjectFunc)          NULL,        D_CO_603E9EC,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_25,  */  {(void*)     D_CO_6014670, 0, (ObjectFunc)          NULL,        D_CO_603EA08,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_26,  */  {(void*)     D_CO_6010A50, 0, (ObjectFunc)          NULL,        D_CO_603EA74,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_27,  */  {(void*)     D_CO_60143E0, 0, (ObjectFunc)          NULL,        D_CO_603EAE0,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_28,  */  {(void*)     D_CO_6014A20, 0, (ObjectFunc)          NULL,        D_CO_603EB0C,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_SKULL,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_60064FC,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_0,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_6006518,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_1,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_6006564,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_2,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_60065B0,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_3,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_60065FC,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_4,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_6006648,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_5,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_6006694,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_6,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_60066E0,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_7,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_600672C,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_8,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones,        D_TI_6006778,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_ME_TUNNEL,  */  {(void*) MeteoTunnel_Draw, 1, (ObjectFunc) MeteoTunnel_Update,       gNoHitbox,  6000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_40,  */  {(void*) func_edisplay_80059F68, 1, (ObjectFunc) func_enmy_80066D5C,        D_CO_603E4A4,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_41,  */  {(void*) func_edisplay_80059FDC, 1, (ObjectFunc) func_enmy_80066EA8,        D_CO_603E4DC,   300.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_42,  */  {(void*) Scenery42_Draw, 1, (ObjectFunc) Scenery42_Update,        D_CO_603E514,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_43,  */  {(void*)     D_ZO_6024AC0, 0, (ObjectFunc)          NULL,        D_ZO_602B9EC,   200.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_44,  */  {(void*)     D_ZO_600F560, 0, (ObjectFunc)          NULL,        D_ZO_602BA20,  1500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_45,  */  {(void*)     D_ZO_600EC90, 0, (ObjectFunc)          NULL,        D_ZO_602BAE4,  1500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_46,  */  {(void*)     D_ZO_600E820, 0, (ObjectFunc)          NULL,        D_ZO_602BBD8,  1500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_47,  */  {(void*)     D_ZO_601FCB0, 0, (ObjectFunc)          NULL,        D_ZO_602BC54,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_48,  */  {(void*) func_edata_800594F0, 1, (ObjectFunc)          NULL,        D_VE1_601B4E0,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_49,  */  {(void*) func_edata_800595D0, 1, (ObjectFunc)          NULL,        D_VE1_601B4FC,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_50,  */  {(void*)     D_VE1_6007410, 0, (ObjectFunc)          NULL,        D_VE1_601B518,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_51,  */  {(void*)     D_VE1_6006F50, 0, (ObjectFunc)          NULL,        D_VE1_601B584,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_52,  */  {(void*)     D_VE1_6005780, 0, (ObjectFunc) Venom1_80193540,        D_VE1_601B5F4,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_53,  */  {(void*)     D_VE1_6003610, 0, (ObjectFunc)          NULL,        D_VE1_601B644,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_54,  */  {(void*)     D_CO_6000E00, 0, (ObjectFunc) Scenery54_Update,        D_CO_603E0EC,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_55,  */  {(void*)     D_CO_6013B50, 0, (ObjectFunc)          NULL,        D_CO_603E88C,  1000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_56,  */  {(void*) Corneria_8018F31C, 2, (ObjectFunc) Corneria_8018F044,        D_CO_603E8A8,  1000.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_57,  */  {(void*) Titania_8018F8B8, 1, (ObjectFunc) Titania_8018F4D8,        D_TI_6006BF0,   800.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_58,  */  {(void*)     D_TI1_700BE00, 0, (ObjectFunc)          NULL,        D_TI_6006C44,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_59,  */  {(void*)     D_MA_6024010, 0, (ObjectFunc)          NULL,        D_MA_603626C,   300.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_60,  */  {(void*)     D_MA_6027180, 0, (ObjectFunc)          NULL,        D_MA_6036288,   400.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_61,  */  {(void*) Macbeth_801A2A78, 1, (ObjectFunc)          NULL,        D_MA_60362A4,   200.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_62,  */  {(void*)     D_MA_60270E0, 0, (ObjectFunc)          NULL,       gNoHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_63,  */  {(void*)     D_MA_6013960, 0, (ObjectFunc)          NULL,        D_MA_6036894,   500.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_64,  */  {(void*)     D_MA_600AF40, 0, (ObjectFunc)          NULL,        D_MA_60368E0,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_65,  */  {(void*) Macbeth_801A6608, 1, (ObjectFunc)          NULL,        D_MA_6036724,   400.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_66,  */  {(void*)     D_MA_601F1D0, 0, (ObjectFunc)          NULL,        D_MA_60362D8,  2500.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_67,  */  {(void*)     D_MA_60238F0, 0, (ObjectFunc)          NULL,        D_MA_6036328,  2000.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_68,  */  {(void*)     D_MA_601B7C0, 0, (ObjectFunc)          NULL,        D_MA_60362F4,  2500.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_69,  */  {(void*)     D_MA_6030500, 0, (ObjectFunc)          NULL,        D_MA_6036370,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_70,  */  {(void*)     D_MA_602DAE0, 0, (ObjectFunc)          NULL,        D_MA_603638C,  1900.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_71,  */  {(void*)     D_MA_6027900, 0, (ObjectFunc)          NULL,        D_MA_60363B8,  1900.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_72,  */  {(void*)     D_MA_602DB80, 0, (ObjectFunc)          NULL,        D_MA_60363E4,  1100.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_73,  */  {(void*)     D_MA_6030630, 0, (ObjectFunc)          NULL,        D_MA_6036410,  1100.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_74,  */  {(void*)     D_MA_602DC20, 0, (ObjectFunc)          NULL,        D_MA_603643C,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_75,  */  {(void*)     D_MA_601B0D0, 0, (ObjectFunc)          NULL,        D_MA_6036760,  3000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_76,  */  {(void*)     D_MA_60075D0, 0, (ObjectFunc)          NULL,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_77,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,        D_MA_6036344,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_78,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_79,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_80,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_81,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_82,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_83,  */  {(void*) Macbeth_801A3240, 1, (ObjectFunc) Macbeth_801A2DD8,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_84,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_85,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_86,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_87,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_88,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_89,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_90,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_91,  */  {(void*) Macbeth_801A2B24, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_92,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_93,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_94,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_95,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_96,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_97,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_98,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_99,  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_100  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_101  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_102  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_103  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_104  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc) Macbeth_801A0BD8,        D_MA_6036594,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_105  */  {(void*) Macbeth_801A23AC, 1, (ObjectFunc)          NULL,        D_MA_6036204,  1300.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_106  */  {(void*)     D_SY_60097E0, 0, (ObjectFunc)          NULL,        D_SY_6034478,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_107  */  {(void*)     D_SY_601D730, 0, (ObjectFunc)          NULL,        D_SY_603450C,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_108  */  {(void*)     D_SY_60102C0, 0, (ObjectFunc)          NULL,        D_SY_6034588,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_109  */  {(void*)     D_SY_60036A0, 0, (ObjectFunc) SectorY_801A4E44,        D_SY_6034664,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_110  */  {(void*)     D_SY_6005360, 0, (ObjectFunc)          NULL,        D_SY_6034770,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_111  */  {(void*) Scenery111_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_112  */  {(void*)     D_SY_600F6C0, 0, (ObjectFunc) SectorY_801A52B8,        D_SY_60347F0,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_113  */  {(void*)     D_SY_601B610, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_114  */  {(void*)     D_SY_601C6A0, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_115  */  {(void*)     D_SY_60188D0, 0, (ObjectFunc)          NULL,        D_SY_603486C,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_116  */  {(void*)     D_SY_60034D0, 0, (ObjectFunc)          NULL,        D_SY_60347D4,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_117  */  {(void*)     D_AQ_60231C0, 0, (ObjectFunc)          NULL,        D_AQ_6030C60,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_118  */  {(void*)     D_AQ_6011EE0, 0, (ObjectFunc)          NULL,        D_AQ_6030C7C,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_119  */  {(void*)     D_AQ_6015730, 0, (ObjectFunc)          NULL,        D_AQ_6030D74,  2000.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_120  */  {(void*)     D_AQ_601DE60, 0, (ObjectFunc)          NULL,        D_AQ_6030DF8,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_121  */  {(void*)     D_AQ_602B4C0, 0, (ObjectFunc)          NULL,        D_AQ_6030E14,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_122  */  {(void*)     D_AQ_600EE10, 0, (ObjectFunc)          NULL,        D_AQ_6030E30_Hitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_123  */  {(void*)     D_AQ_60120F0, 0, (ObjectFunc)          NULL,        D_AQ_6030E4C,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_124  */  {(void*)     D_AQ_600EEF0, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_125  */  {(void*)     D_AQ_600BF80, 0, (ObjectFunc)          NULL,        D_AQ_6030E68,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_126  */  {(void*) Aquas_801BE1FC, 1, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_127  */  {(void*)     D_VE1_9005C80, 0, (ObjectFunc) Venom1_801924A8,        D_VE1_601B678,  1000.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_128  */  {(void*)     D_VE1_9003F50, 0, (ObjectFunc)          NULL,        D_VE1_601B6C4,  3200.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_129  */  {(void*)     D_VE1_900F060, 0, (ObjectFunc)          NULL,        D_VE1_601B710,  3200.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_130  */  {(void*)     D_VE1_900F1D0, 0, (ObjectFunc)          NULL,        D_VE1_601B75C,  3200.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_131  */  {(void*) Andross_801935D4, 1, (ObjectFunc) Andross_8019356C,        D_ANDROSS_C038BD8,   500.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_132  */  {(void*) Andross_8019350C, 1, (ObjectFunc) Andross_80193380,        D_ANDROSS_C038A48,   500.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_133  */  {(void*)     D_TR_60030F0, 0, (ObjectFunc)          NULL,        D_TR_6009CC4,  1000.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_SCENERY_134  */  {(void*)     D_VE2_6003000, 0, (ObjectFunc)          NULL,        D_ANDROSS_C038BA4,     0.0f,  0, 0, 41, 1,   0.0f,  0 },
  /* OBJ_SCENERY_135  */  {(void*) D_TI_6006890, 0, (ObjectFunc)          NULL,        D_ANDROSS_C038B40,     0.0f,  0, 0, 41, 1,   0.0f,  0 },
  /* OBJ_SCENERY_136  */  {(void*)     D_VE2_6002990, 0, (ObjectFunc)          NULL,        D_ANDROSS_C038B40,     0.0f,  0, 0, 41, 1,   0.0f,  0 },
  /* OBJ_SCENERY_137  */  {(void*)     D_VE2_6004170, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0,  0, 1,   0.0f,  0 },
  /* OBJ_SCENERY_138  */  {(void*)     D_versus_3017600, 0, (ObjectFunc)          NULL,        D_versus_302EE64,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_139  */  {(void*)     D_versus_3017600, 0, (ObjectFunc)          NULL,        D_versus_302EE80,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_140  */  {(void*)     D_versus_30173C0, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_141  */  {(void*)     D_versus_30174E0, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_142  */  {(void*)     D_versus_301B080, 0, (ObjectFunc)          NULL,        D_versus_302EE9C,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_143  */  {(void*)     D_versus_3016B00, 0, (ObjectFunc)          NULL,        D_versus_302EE00,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_144  */  {(void*)     D_versus_3013780, 0, (ObjectFunc)          NULL,        D_versus_302ED4C,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_145  */  {(void*)     D_versus_3013580, 0, (ObjectFunc)          NULL,        D_versus_302ED98,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_146  */  {(void*)     D_versus_3012ED0, 0, (ObjectFunc)          NULL,        D_versus_302EDB4,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_147  */  {(void*)          NULL, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_148  */  {(void*)     D_FO_60079B0, 0, (ObjectFunc)          NULL,        D_FO_600FF80,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_149  */  {(void*)     D_FO_6007D80, 0, (ObjectFunc)          NULL,        D_FO_600FFA0,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_150  */  {(void*)     D_FO_6006310, 0, (ObjectFunc)          NULL,        D_FO_600FFC0,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_151  */  {(void*)     D_FO_60066E0, 0, (ObjectFunc)          NULL,        D_FO_600FEB8,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_152  */  {(void*)     D_BO_600F4C0, 0, (ObjectFunc)          NULL,        D_BO_6011C10,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_153  */  {(void*)     D_BO_600B8B0, 0, (ObjectFunc)          NULL,        D_BO_6011C48,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_154  */  {(void*)     aKaFLBaseDL, 0, (ObjectFunc)          NULL,        D_KA_601115C,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_155  */  {(void*)          NULL, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_156  */  {(void*) SectorY_80197CB8, 1, (ObjectFunc)          NULL,        D_SY_6034368,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_157  */  {(void*)     D_SZ_6001DA0, 0, (ObjectFunc)          NULL,        D_SZ_600924C,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_158  */  {(void*)     D_SZ_6001360, 0, (ObjectFunc)          NULL,        D_SZ_60092E8,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_159  */  {(void*)     D_VE2_6008370, 0, (ObjectFunc)          NULL,        D_VE2_601668C,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_160  */  {(void*)     D_VE2_6010960, 0, (ObjectFunc)          NULL,        D_VE2_6016714,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_POLE  */  {(void*)     D_CO_602F7C0, 0, (ObjectFunc) Sprite_UpdateDoodad,        D_CO_603E468,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_TREE  */  {(void*)     D_CO_601C9B0, 0, (ObjectFunc) Sprite_UpdateDoodad,        D_CO_603E484,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_FO_POLE  */  {(void*)     D_FO_600A420, 0, (ObjectFunc) Sprite_UpdateDoodad,        D_FO_600FE9C,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_FOG_SHADOW  */  {(void*) FogShadow_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  1800.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_RUIN1  */  {(void*)     D_CO_602DCA0, 0, (ObjectFunc)          NULL,       gNoHitbox,  -100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_RUIN2  */  {(void*)     D_CO_601F500, 0, (ObjectFunc)          NULL,       gNoHitbox,  -100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_167  */  {(void*) Sprite167_Draw, 1, (ObjectFunc) Sprite167_Update,       gNoHitbox,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_168  */  {(void*) Sprite168_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_TI_CACTUS  */  {(void*)     D_TI_60023B0, 0, (ObjectFunc) Titania_Cactus_Update,        D_TI_60068BC,   100.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_SMOKE  */  {(void*)          NULL, 1, (ObjectFunc) Corneria_801875A4,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER1  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger1_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER2  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger2_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER3  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger3_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER4  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger4_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_GFOX_TARGET  */  {(void*)          NULL, 1, (ObjectFunc)          NULL,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_176 */  {(void*) Corneria_8018BAAC, 2, (ObjectFunc) Corneria_8018AED0,        D_CO_603E5D0,   500.0f,  0, 0, 39, 1, 200.0f,  1 },
  /* OBJ_ACTOR_177 */  {(void*) Corneria_8018BBA4, 2, (ObjectFunc) Corneria_8018B15C,        D_CO_603E5D0,   500.0f,  0, 0, 39, 1, 200.0f,  1 },
  /* OBJ_ACTOR_178 */  {(void*) Corneria_8018BBF8, 2, (ObjectFunc) Corneria_8018B418,        D_CO_603E5D0,   500.0f,  0, 0, 39, 1, 200.0f,  1 },
  /* OBJ_ACTOR_179 */  {(void*) Corneria_8018BD7C, 2, (ObjectFunc) Corneria_8018B58C,        D_CO_603E604,   500.0f,  0, 0, 39, 1,   0.0f,  1 },
  /* OBJ_ACTOR_180 */  {(void*) func_edisplay_8005B6A4, 1, (ObjectFunc) func_enmy_80066A80,       gNoHitbox,  1000.0f,  0, 0, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_181 */  {(void*)     D_ME_6018C00, 0, (ObjectFunc) Meteo_8018756C,        D_ME_602F6EC,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_182 */  {(void*) func_edisplay_8005B71C, 1, (ObjectFunc) Meteo_80187650,        D_ME_602F708,   100.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_183 */  {(void*) Meteo_8018DA6C, 1, (ObjectFunc) Meteo_8018D9EC,       gNoHitbox,   100.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_184 */  {(void*) Meteo_8018DAEC, 1, (ObjectFunc) Meteo_8018D9EC,       gNoHitbox,   100.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_185 */  {(void*) Meteo_8018DB6C, 1, (ObjectFunc) Meteo_8018D9EC,       gNoHitbox,   100.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_186 */  {(void*) func_edisplay_8005B7CC, 1, (ObjectFunc) Meteo_8018795C,        D_ME_602F724,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_187 */  {(void*)     D_ME_6018450, 0, (ObjectFunc) Meteo_801877C4,        D_ME_602F740,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_188 */  {(void*) Aquas_801BEC74, 1, (ObjectFunc) Aquas_801BEC68,        D_AQ_6030BE0,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_DEBRIS */  {(void*) ActorDebris_Draw, 1, (ObjectFunc) ActorDebris_Update,       gNoHitbox,     0.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_190 */  {(void*) func_edisplay_8005B848, 1, (ObjectFunc) func_enmy_800656D4,       gActor190_191Hitbox,   100.0f,  0, 1, 39, 0,   1.0f,  0 },
  /* OBJ_ACTOR_191 */  {(void*) func_edisplay_8005B848, 1, (ObjectFunc) func_enmy_800656D4,       gActor190_191Hitbox,   100.0f,  0, 1, 39, 0,   1.0f,  0 },
  /* OBJ_ACTOR_192 */  {(void*) func_edisplay_8005B9A4, 1, (ObjectFunc) func_enmy_8006654C,        D_CO_603E54C,   200.0f,  0, 1, 39, 0,  50.0f,  1 },
  /* OBJ_ACTOR_193 */  {(void*) func_edisplay_8005BA30, 1, (ObjectFunc) func_enmy_800669A0,        D_CO_603E598,   100.0f,  0, 1, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_194 */  {(void*) Actor194_Draw, 1, (ObjectFunc) Actor194_Update,       gActor194Hitbox,   200.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_CUTSCENE */  {(void*) ActorCutscene_Draw, 1, (ObjectFunc) ActorCutscene_Update,       gNoHitbox, 20000.0f,  0, 1, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_196 */  {(void*) Actor196_Draw, 1, (ObjectFunc) Actor196_Update,        D_CO_603E5B4,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ALLRANGE */  {(void*) ActorAllRange_Draw, 1, (ObjectFunc) ActorAllRange_Update,       gActorAllRangeHItbox, 20000.0f,  0, 1, 39, 1,   1.0f,  1 },
  /* OBJ_ACTOR_TEAM_BOSS */  {(void*) ActorAllRange_Draw, 1, (ObjectFunc) ActorTeamBoss_Update,       gTeamHitbox, 20000.0f,  0, 0, 39, 1,   0.0f,  0 },
  /* OBJ_ACTOR_199 */  {(void*) Andross_80188448, 1, (ObjectFunc) Andross_801880E4,       gNoHitbox, 20000.0f,  0, 0, 39, 1,   0.0f,  0 },
  /* OBJ_ACTOR_EVENT */  {(void*) ActorEvent_Draw, 1, (ObjectFunc) ActorEvent_Update,       gNoHitbox,  2000.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_201 */  {(void*) Actor201_Draw, 1, (ObjectFunc) Actor201_Update,        D_ME_602F684,   100.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_202 */  {(void*) Actor202_Draw, 1, (ObjectFunc) Actor202_Update,        D_ME_602F6A0,   100.0f,  0, 1, 39, 0, 180.0f,  1 },
  /* OBJ_ACTOR_SLIPPY_SX */  {(void*) SectorX_8018F884, 1, (ObjectFunc) SectorX_8018F330,       gNoHitbox,  1000.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_204 */  {(void*) SectorY_Actor204_Draw, 1, (ObjectFunc) SectorY_Actor204_Update,        D_SY_603405C,  1000.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_205 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_8019C778,        D_MA_60359C8, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_206 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_801AC438,        D_MA_6035A48, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_207 */  {(void*) Macbeth_801AC294, 2, (ObjectFunc) Macbeth_801A7E7C,        D_MA_603677C, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_208 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_8019EA60,        D_MA_6035A14, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_209 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_8019D700,        D_MA_6035AE0, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_210 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_8019CE88,        D_MA_6035D9C, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_211 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_8019E410,        D_MA_6035E04, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_212 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_8019FF9C,        D_MA_60360C0, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_213 */  {(void*) Macbeth_801A12C4, 1, (ObjectFunc) Macbeth_8019EE68,        D_MA_6036154, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_214 */  {(void*) Macbeth_801A43BC, 1, (ObjectFunc) Macbeth_801A3E98,        D_MA_6036458,   300.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_215 */  {(void*) Macbeth_801A4A64, 1, (ObjectFunc) Macbeth_801A46A0,        D_MA_60364C0,   300.0f,  0, 1, 40, 1,   0.0f,  1 },
  /* OBJ_ACTOR_216 */  {(void*) Macbeth_801A5F90, 1, (ObjectFunc) Macbeth_801A5E54,        D_MA_60366EC,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_217 */  {(void*) Macbeth_801A6100, 1, (ObjectFunc) Macbeth_801A5FD0,        D_MA_6036708,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_218 */  {(void*) Macbeth_801A6540, 1, (ObjectFunc) Macbeth_801A6144,        D_MA_6036728,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_219 */  {(void*) Macbeth_801A68EC, 1, (ObjectFunc) Macbeth_801A67C8,        D_MA_6036744,   300.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_220 */  {(void*) Macbeth_801ADAC8, 1, (ObjectFunc) Macbeth_801AD6F0,        D_MA_6036930,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_221 */  {(void*) Macbeth_801AE2C0, 1, (ObjectFunc) Macbeth_801ADD68,        D_MA_603694C,   300.0f,  0, 0, 40, 1,   1.0f,  0 },
  /* OBJ_ACTOR_222 */  {(void*) Macbeth_801AEEFC, 1, (ObjectFunc) Macbeth_801AEC04,        D_MA_6036968,   300.0f,  0, 0, 40, 1,   1.0f,  0 },
  /* OBJ_ACTOR_223 */  {(void*) Macbeth_801A54E8, 1, (ObjectFunc) Macbeth_801A4B24,        D_MA_60364DC,   300.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_224 */  {(void*)          NULL, 1, (ObjectFunc) Titania_80189194,       gNoHitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_225 */  {(void*)     D_TI1_700AB70, 0, (ObjectFunc) Titania_8018AB44,        D_TI_60064AC,    50.0f,  0, 0, 39, 1,   1.0f,  0 },
  /* OBJ_ACTOR_226 */  {(void*) Titania_80189AFC, 1, (ObjectFunc) Titania_801895B8,        D_TI_60064C8,   300.0f,  0, 0, 39, 1,  70.0f,  1 },
  /* OBJ_ACTOR_227 */  {(void*) Titania_8018E5B4, 1, (ObjectFunc) Titania_8018E54C,        D_TI_60067C4,     0.0f,  0, 0, 39, 1,   0.0f,  0 },
  /* OBJ_ACTOR_228 */  {(void*) Titania_8018EF14, 1, (ObjectFunc) Titania_8018E5F8,        D_TI_6006808,     0.0f,  0, 0, 39, 1,   1.0f,  1 },
  /* OBJ_ACTOR_229 */  {(void*) Titania_8018E2D8, 1, (ObjectFunc) Titania_8018C8A8,        D_TI_6006A3C,  1000.0f,  0, 0, 20, 1,   0.0f,  1 },
  /* OBJ_ACTOR_230 */  {(void*) Titania_8018AABC, 1, (ObjectFunc) Titania_8018A544,        D_TI_600683C,     0.0f,  0, 1, 39, 1,   0.0f,  1 },
  /* OBJ_ACTOR_231 */  {(void*) Titania_8018BE84, 1, (ObjectFunc) Titania_8018B9D0,        D_TI_6006858,     0.0f,  0, 0, 39, 1,   0.0f,  1 },
  /* OBJ_ACTOR_232 */  {(void*) Titania_8018B6AC, 1, (ObjectFunc) Titania_8018B268,    D_TI_6006890,     0.0f,  0, 0, 39, 1,  20.0f,  1 },
  /* OBJ_ACTOR_233 */  {(void*) Titania_8018A1C0, 1, (ObjectFunc) Titania_80189CC8,        D_TI_60068F0,   200.0f,  0, 0, 39, 1,   1.0f,  1 },
  /* OBJ_ACTOR_234 */  {(void*) Actor234_Draw, 1, (ObjectFunc) Actor234_Update,       gNoHitbox,  2000.0f,  0, 0, 39, 0,   0.0f,  5 },
  /* OBJ_ACTOR_235 */  {(void*) Zoness_80190430, 2, (ObjectFunc) Zoness_801904CC,        D_ZO_602C294,  1000.0f,  0, 1, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_236 */  {(void*) Zoness_80190F08, 1, (ObjectFunc) Zoness_80190A00,        D_ZO_602BC58,  5000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_237 */  {(void*) Actor237_Draw, 1, (ObjectFunc) Actor237_Update,       gNoHitbox,   200.0f,  0, 0, 40, 0,   0.0f,  2 },
  /* OBJ_ACTOR_238 */  {(void*) Zoness_801914C4, 2, (ObjectFunc) Zoness_80191010,       gCubeHitbox100,   200.0f,  0, 1, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_239 */  {(void*)          NULL, 1, (ObjectFunc)          NULL,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_240 */  {(void*) Zoness_80191B4C, 1, (ObjectFunc) Zoness_80191680,       gCubeHitbox100,  1500.0f,  0, 1, 40, 0,  20.0f,  0 },
  /* OBJ_ACTOR_241 */  {(void*) Zoness_80191DB0, 1, (ObjectFunc) Zoness_80191BC4,       gActor241Hitbox,  1500.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_242 */  {(void*) Zoness_80191FFC, 2, (ObjectFunc) Zoness_80192094,        D_ZO_602BE3C,   500.0f,  0, 0, 40, 0,   1.0f,  0 },
  /* OBJ_ACTOR_243 */  {(void*) Zoness_80192C18, 2, (ObjectFunc) Zoness_80192834,       gCubeHitbox100,     0.0f,  0, 1, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_244 */  {(void*) Zoness_80193240, 2, (ObjectFunc) Zoness_80192E64,        D_ZO_602BE58,  2000.0f,  0, 0, 40, 0,  50.0f,  0 },
  /* OBJ_ACTOR_245 */  {(void*) Zoness_8019983C, 1, (ObjectFunc) Zoness_8019969C,       gCubeHitbox100,   200.0f,  0, 0, 40, 0,   1.0f,  0 },
  /* OBJ_ACTOR_246 */  {(void*) Zoness_80199E24, 1, (ObjectFunc) Zoness_80199A28,       gCubeHitbox100,  2000.0f,  0, 0, 40, 0,   1.0f,  0 },
  /* OBJ_ACTOR_247 */  {(void*) Zoness_8019D3C4, 1, (ObjectFunc) Zoness_8019D15C,        D_ZO_602BFC4,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_248 */  {(void*) Zoness_8019A1FC, 1, (ObjectFunc) Zoness_80199F10,       gCubeHitbox150,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_249 */  {(void*) Zoness_8019ACCC, 1, (ObjectFunc) Zoness_8019A5D4,       gCubeHitbox200,  5000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_250 */  {(void*) Zoness_8019B7DC, 1, (ObjectFunc) Zoness_8019B548,        D_ZO_602C1D4, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_251 */  {(void*) Zoness_8019BDE0, 2, (ObjectFunc) Zoness_8019B854,        D_ZO_602C218,  1000.0f,  0, 0, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_252 */  {(void*) Zoness_8019C1CC, 1, (ObjectFunc) Zoness_8019BE48,        D_ZO_602C234,   200.0f,  0, 0, 40, 0,  80.0f,  1 },
  /* OBJ_ACTOR_253 */  {(void*) Zoness_8019C83C, 1, (ObjectFunc) Zoness_8019C454,        D_ZO_602C250,   300.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_254 */  {(void*) Zoness_8019CE58, 1, (ObjectFunc) Zoness_8019CBEC,        D_ZO_602C2B0,   300.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_255 */  {(void*) Aquas_801AE168, 1, (ObjectFunc) Aquas_801AD6C0,        D_AQ_6030BFC,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_256 */  {(void*) Aquas_801AEB44, 1, (ObjectFunc) Aquas_801AE3D8,        D_AQ_6030C18, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_257 */  {(void*) Aquas_801B099C, 1, (ObjectFunc) Aquas_801AFA5C,        D_AQ_6030C44, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_258 */  {(void*) Aquas_801B0EC0, 1, (ObjectFunc) Aquas_801B0B60,       gCubeHitbox100,   200.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_259 */  {(void*) Aquas_801B619C, 2, (ObjectFunc) Aquas_801B638C,        D_AQ_6031398, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_260 */  {(void*) Aquas_801B90DC, 2, (ObjectFunc) Aquas_801B7C78,        D_AQ_60313CC,   300.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_261 */  {(void*) Aquas_801B504C, 2, (ObjectFunc) Aquas_801B50E8,        D_AQ_6031400,   300.0f,  0, 0, 40, 0,   0.0f,  1 },
  /* OBJ_ACTOR_262 */  {(void*) Aquas_801B7A24, 2, (ObjectFunc) Aquas_801B6FF8,        D_AQ_603144C,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_263 */  {(void*) Aquas_801BA108, 2, (ObjectFunc) Aquas_801B91A4,        D_AQ_6031480,   200.0f,  0, 0, 40, 0,   0.0f,  1 },
  /* OBJ_ACTOR_264 */  {(void*) Aquas_801BA4E4, 1, (ObjectFunc) Aquas_801BA26C,       gCubeHitbox100,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_265 */  {(void*) Aquas_801BAD7C, 1, (ObjectFunc) Aquas_801BA6A4,        D_AQ_6031500,   200.0f,  0, 0, 40, 0,   0.0f,  1 },
  /* OBJ_ACTOR_266 */  {(void*) Aquas_801BB204, 2, (ObjectFunc) Aquas_801BADF8,        D_AQ_6031538,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_267 */  {(void*) Aquas_801BC930, 2, (ObjectFunc) Aquas_801BB79C,        D_AQ_6031554,   800.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_268 */  {(void*) Aquas_801BDE6C, 1, (ObjectFunc) Aquas_801BD54C,        D_AQ_6031570, 10000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_269 */  {(void*) Aquas_801BD264, 1, (ObjectFunc) Aquas_801BC9A0,        D_AQ_6030D20,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_270 */  {(void*) Aquas_801BEB1C, 1, (ObjectFunc) Aquas_801BE3F8,        D_AQ_60314C8,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_271 */  {(void*) Actor271_Draw, 2, (ObjectFunc) Actor271_Update,        D_BO_6011B24,     0.0f,  0, 0, 39, 0, 730.0f,  1 },
  /* OBJ_ACTOR_272 */  {(void*) Actor272_Draw, 1, (ObjectFunc) Actor272_Update,        D_BO_6011BF4,     0.0f,  0, 0, 39, 0, 150.0f,  1 },
  /* OBJ_ACTOR_273 */  {(void*) Fortuna_80188FE4, 2, (ObjectFunc) Fortuna_80188AD0,        D_FO_600FF30,     0.0f,  0, 0, 39, 0, 220.0f,  1 },
  /* OBJ_ACTOR_274 */  {(void*) SectorZ_8019E3A8, 1, (ObjectFunc) SectorZ_8019E234,       gCubeHitbox200,     0.0f,  0, 0, 39, 0,   1.0f,  0 },
  /* OBJ_ACTOR_275 */  {(void*) Solar_8019F7AC, 1, (ObjectFunc) Solar_8019F20C,       gCubeHitbox100,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_276 */  {(void*) Solar_8019F7AC, 1, (ObjectFunc) Solar_8019F20C,       gCubeHitbox100,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_277 */  {(void*) Solar_8019F7AC, 1, (ObjectFunc) Solar_8019F20C,       gCubeHitbox200,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_278 */  {(void*)          NULL, 1, (ObjectFunc) Solar_8019EA7C,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  1 },
  /* OBJ_ACTOR_279 */  {(void*)          NULL, 1, (ObjectFunc) Solar_801A003C,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  1 },
  /* OBJ_ACTOR_280 */  {(void*)     D_VE1_900DD20, 0, (ObjectFunc) Venom1_80192518,        D_VE1_601B7F8,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_281 */  {(void*) Venom1_80192E2C, 1, (ObjectFunc) Venom1_80192CD4,        D_VE1_601B830,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_282 */  {(void*)     D_VE1_901DA50, 0, (ObjectFunc) Venom1_80192CD4,        D_VE1_601B868,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_283 */  {(void*)     D_VE1_9023AD0, 0, (ObjectFunc) Venom1_80192EB0,        D_VE1_601B8A0,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_284 */  {(void*) Venom1_801934D0, 1, (ObjectFunc) Venom1_801933DC,        D_VE1_601B8D8,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_285 */  {(void*) Andross_80193244, 1, (ObjectFunc) Andross_80192E94,       gCubeHitbox100,  1000.0f,  0, 0, 20, 0,   1.0f,  1 },
  /* OBJ_ACTOR_286 */  {(void*) Andross_80188660, 1, (ObjectFunc) Andross_80188528,       gCubeHitbox100,  1000.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_ACTOR_287 */  {(void*)          NULL, 1, (ObjectFunc) Andross_80189724,       gNoHitbox,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_288 */  {(void*)          NULL, 1, (ObjectFunc) Andross_801893B8,       gNoHitbox,  1000.0f,  0, 0, 20, 1,   0.0f,  0 },
  /* OBJ_ACTOR_289 */  {(void*) func_edata_800596B0, 1, (ObjectFunc) Andross_80189470,       gNoHitbox,  1000.0f,  0, 0, 20, 1,   0.0f,  0 },
  /* OBJ_ACTOR_290 */  {(void*)          NULL, 1, (ObjectFunc) Andross_8018933C,       gNoHitbox,  1000.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_ACTOR_SUPPLIES */  {(void*) ActorSupplies_Draw, 1, (ObjectFunc) ActorSupplies_Update,       gCubeHitbox150,  1000.0f,  0, 0,  0, 0,   1.0f,  0 },
  /* OBJ_BOSS_292 */  {(void*) Corneria_8018AA74, 2, (ObjectFunc) Corneria_80189058,        D_CO_603E620, 20000.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_293 */  {(void*) Corneria_8018ECAC, 1, (ObjectFunc) Corneria_8018C19C,        D_CO_603E840, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_294 */  {(void*) Corneria_8018ED78, 1, (ObjectFunc) Corneria_8018DDAC,        D_CO_603E714, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_295 */  {(void*) Corneria_8018EE84, 1, (ObjectFunc) Corneria_8018E290,        D_CO_603E748, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_296 */  {(void*) Corneria_8018EF90, 1, (ObjectFunc) Corneria_8018E76C,        D_CO_603E7C4, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_297 */  {(void*) Meteo_8018BACC, 1, (ObjectFunc) Meteo_8018978C,        D_ME_602F75C, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_298 */  {(void*) Meteo_801887D0, 1, (ObjectFunc) Meteo_80188344,        D_ME_602FA50, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_299 */  {(void*) Boss299_Draw, 2, (ObjectFunc) Boss299_Update,       gNoHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_300 */  {(void*) Boss300_Draw, 1, (ObjectFunc) Boss300_Update,       gNoHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_301 */  {(void*) Aquas_Boss301_Draw, 1, (ObjectFunc) Aquas_Boss301_Update,        D_AQ_6030B10,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_A6 */  {(void*) Area6_Boss_Draw, 1, (ObjectFunc) Area6_Boss_Update,        D_A6_6028454,  2000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_303 */  {(void*) SectorX_80193434, 2, (ObjectFunc) SectorX_80190078,        D_SX_6032550, 20000.0f,  0, 0, 20, 0,   0.0f, 10 },
  /* OBJ_BOSS_304 */  {(void*) SectorX_8018FF84, 2, (ObjectFunc) SectorX_8018FE38,        D_SX_6032488,  1000.0f,  0, 0, 20, 0,   0.0f, 10 },
  /* OBJ_BOSS_305 */  {(void*) SectorX_80190020, 2, (ObjectFunc) SectorX_8018FF20,        D_SX_60324EC,  1000.0f,  0, 0, 20, 0,   0.0f, 10 },
  /* OBJ_BOSS_TI */  {(void*) Titania_Boss_Draw, 1, (ObjectFunc) Titania_Boss_Update,D_TI_801B83A8,  1000.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_ZO */  {(void*) Zoness_Boss_Draw, 2, (ObjectFunc) Zoness_Boss_Update,        D_ZO_602C044,  1000.0f,  0, 0, 40, 0,   1.0f, 10 },
  /* OBJ_BOSS_FO */  {(void*) HUD_BossFO_Draw, 1, (ObjectFunc) HUD_BossFO_Update,        D_FO_600FFE0,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_309 */  {(void*) Boss309_Draw, 1, (ObjectFunc) Boss309_Update,       gNoHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_310 */  {(void*) Boss310_Draw, 1, (ObjectFunc) Boss310_Update,       gNoHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_311 */  {(void*) Bolse_80191AFC, 2, (ObjectFunc) Bolse_801912FC,        D_BO_6011C80,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_VE2 */  {(void*) Venom2_Boss_Draw, 2, (ObjectFunc) Venom2_Boss_Update,        D_VE2_60166F4,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_SZ */  {(void*) SectorZ_Boss_Draw, 1, (ObjectFunc) SectorZ_Boss_Update,        D_SZ_6009388,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_SY */  {(void*) SectorY_Boss_Draw, 2, (ObjectFunc) SectorY_Boss_Update,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_SO */  {(void*) Solar_Boss_Draw, 2, (ObjectFunc) Solar_Boss_Update,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_KA */  {(void*) Katina_BossDraw, 1, (ObjectFunc) Katina_BossUpdate,        D_KA_6011058,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_KA_BASE */  {(void*) Katina_Base_Draw, 1, (ObjectFunc) Katina_BaseUpdate,        D_KA_601115C,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_AQ */  {(void*) Aquas_Boss_Draw, 2, (ObjectFunc) Aquas_Boss_Update,        D_AQ_6030F74, 10000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_VE1 */  {(void*) Venom1_Boss_Draw, 1, (ObjectFunc) Venom1_Boss_Update,D_VE1_8019A9B8,  3000.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_320 */  {(void*) Andross_801928C8, 2, (ObjectFunc) Andross_8018DBF0,        D_ANDROSS_C038DC0, 10000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_321 */  {(void*) Andross_8018B8C0, 1, (ObjectFunc) Andross_80189B70,        D_ANDROSS_C038F24, 10000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_ITEM_LASERS  */  {(void*) ItemLasers_Draw, 1, (ObjectFunc) ItemLasers_Update,       gItemLasersHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_CHECKPOINT  */  {(void*) ItemCheckpoint_Draw, 1, (ObjectFunc) ItemCheckpoint_Update,       gItemCheckpointHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_SILVER_RING  */  {(void*) ItemSilverRing_Draw, 1, (ObjectFunc) ItemSupplyRing_Update,       gItemSupplyRingHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_SILVER_STAR  */  {(void*) ItemSilverStar_Draw, 1, (ObjectFunc) ItemSilverStar_Update,       gItemSupplyRingHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_METEO_WARP  */  {(void*) ItemMeteoWarp_Draw, 1, (ObjectFunc) ItemMeteoWarp_Update,       gMeteoWarpHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_BOMB  */  {(void*) ItemBomb_Draw, 1, (ObjectFunc) ItemPickup_Update,       gItemBombHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_SPLIT_X  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_LEFT  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_RIGHT  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_SPLIT_Y  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_UP  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_DOWN  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_RING_CHECK  */  {(void*)          NULL, 1, (ObjectFunc) ItemRingCheck_Update,       gItemRingCheckHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_1UP  */  {(void*)     D_1022120, 0, (ObjectFunc) Item1up_Update,       gCubeHitbox100,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_GOLD_RING  */  {(void*) ItemGoldRing_Draw, 1, (ObjectFunc) ItemGoldRing_Update,       gItemSupplyRingHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_WING_REPAIR  */  {(void*)     D_arwing_3007650, 0, (ObjectFunc) ItemWingRepair_Update,       gItemLasersHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_TRAINING_RING  */  {(void*)     gItemTrainingRingDL, 0, (ObjectFunc) Training_ItemRing_Update,        D_TR_6009CFC,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_FIRE_SMOKE  */  {(void*) func_effect_8007D55C, 1, (ObjectFunc) func_effect_8007D2F4,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_340  */  {(void*) func_effect_8007D55C, 1, (ObjectFunc) func_effect_8007D748,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_341  */  {(void*) func_effect_8007D55C, 1, (ObjectFunc) func_effect_8007D8A8,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_342  */  {(void*) func_effect_8007E330, 1, (ObjectFunc) func_effect_8007E298,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_343  */  {(void*) func_effect_8007CAF0, 1, (ObjectFunc) func_effect_8007C9E0,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_344  */  {(void*) func_effect_8007868C, 1, (ObjectFunc) func_effect_8007E014,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_345  */  {(void*) func_effect_8007879C, 1, (ObjectFunc) func_effect_8007E258,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_346  */  {(void*) func_effect_800788B0, 1, (ObjectFunc) func_effect_8007F438,             NULL,  -200.0f,  1, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_347  */  {(void*) func_effect_800783C0, 1, (ObjectFunc) func_effect_8007B758,             NULL,   100.0f,  1, 0, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_348  */  {(void*) func_effect_80078A64, 1, (ObjectFunc) func_effect_8007F6B0,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_349  */  {(void*)          NULL, 1, (ObjectFunc) func_effect_8007F958,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_350  */  {(void*)          NULL, 1, (ObjectFunc) func_effect_8007FBE0,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_351  */  {(void*) func_effect_80078438, 1, (ObjectFunc) func_effect_8007E3E4,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_352  */  {(void*) func_effect_800784B4, 1, (ObjectFunc) func_effect_8007B62C,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_353  */  {(void*) func_effect_80078B8C, 1, (ObjectFunc) func_effect_8007FE88,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_354  */  {(void*) SectorY_80197C64, 1, (ObjectFunc) func_effect_8007FE88,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_355  */  {(void*) func_effect_80078AEC, 1, (ObjectFunc) func_effect_800802B8,             NULL,   100.0f,  1, 0, 20, 1,   0.0f,  0 },
  /* OBJ_EFFECT_356  */  {(void*) func_effect_80078C84, 1, (ObjectFunc) func_effect_800802F8,             NULL,   100.0f,  1, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_357  */  {(void*) func_effect_800798F0, 1, (ObjectFunc) func_effect_8007968C,             NULL,   100.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_358  */  {(void*) Katina_LaserEnergyParticlesDraw, 1, (ObjectFunc) Katina_LaserEnergyParticlesUpdate,             NULL,   100.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_359  */  {(void*) func_effect_8007AA60, 1, (ObjectFunc) func_effect_8007A994,             NULL,  -100.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_360  */  {(void*) func_effect_8007BEE8, 1, (ObjectFunc) func_effect_8007BE54,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_361  */  {(void*) func_effect_8007BEE8, 1, (ObjectFunc) func_effect_8007BDE0,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_362  */  {(void*) func_effect_8007BEE8, 1, (ObjectFunc) func_effect_8007BCE8,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_363  */  {(void*) func_hud_80094BBC, 1, (ObjectFunc) func_hud_80094954,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_364  */  {(void*) func_effect_8007B9DC, 1, (ObjectFunc) func_effect_8007B960,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_365  */  {(void*) func_effect_8007E5CC, 1, (ObjectFunc) func_effect_8007E45C,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_366  */  {(void*) func_effect_80078550, 1, (ObjectFunc) Aquas_801AC918,             NULL,   100.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_367  */  {(void*) func_effect_80078604, 1, (ObjectFunc) func_effect_8007E648,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_368  */  {(void*) Titania_80188FA8, 1, (ObjectFunc) Titania_80188F60,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_369  */  {(void*) Meteo_8018DCE4, 1, (ObjectFunc) Meteo_80188CAC,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_370  */  {(void*) Meteo_8018DBEC, 1, (ObjectFunc) Meteo_80188FAC,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_371  */  {(void*) Meteo_8018DE14, 1, (ObjectFunc) Meteo_80189114,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_372  */  {(void*) func_effect_80077A00, 1, (ObjectFunc) func_effect_8007AB50,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_373  */  {(void*)          NULL, 1, (ObjectFunc) func_effect_8007A748,             NULL,   500.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_374  */  {(void*) func_effect_8007DED4, 1, (ObjectFunc) func_effect_8007DB70,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_375  */  {(void*) func_effect_8007DAE4, 1, (ObjectFunc) func_effect_8007DA58,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_376  */  {(void*) func_effect_80078CE8, 1, (ObjectFunc) func_effect_80080360,             NULL,  -200.0f,  1, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_377  */  {(void*) func_effect_80078BE0, 1, (ObjectFunc) func_effect_800802D8,             NULL,   100.0f,  1, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_378  */  {(void*) Macbeth_801A5AF0, 1, (ObjectFunc) Macbeth_801A57D0,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_379  */  {(void*) Macbeth_801AEAA0, 1, (ObjectFunc) Macbeth_801AE87C,             NULL,   100.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_380  */  {(void*) Macbeth_801A5D68, 1, (ObjectFunc) Macbeth_801A5B4C,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_381  */  {(void*) func_effect_80077A7C, 1, (ObjectFunc) func_effect_8007B0F4,             NULL,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_382  */  {(void*)          NULL, 1, (ObjectFunc) func_effect_8007B040,             NULL,   200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_383  */  {(void*) func_effect_8007A3C0, 1, (ObjectFunc) func_effect_8007A28C,             NULL, 10000.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_384  */  {(void*) func_effect_80077B84, 1, (ObjectFunc) func_effect_8007B3B8,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_385  */  {(void*) func_effect_80078038, 1, (ObjectFunc) func_effect_8007B5C0,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_386  */  {(void*)          NULL, 1, (ObjectFunc) func_effect_8007C250,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_387  */  {(void*)          NULL, 1, (ObjectFunc) func_effect_8007C8C4,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_388  */  {(void*) func_effect_80077B78, 1, (ObjectFunc) func_effect_8007B670,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_389  */  {(void*) func_effect_800780F8, 1, (ObjectFunc) func_effect_8007B67C,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_390  */  {(void*)          NULL, 1, (ObjectFunc) func_effect_8007C50C,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_391  */  {(void*) func_effect_80083B8C, 1, (ObjectFunc) func_effect_800837EC,             NULL,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_392  */  {(void*) Solar_801A0AF0, 1, (ObjectFunc) Solar_801A0120,             NULL,   300.0f,  1, 2, 10, 0,   0.0f,  0 },
  /* OBJ_EFFECT_393  */  {(void*) func_effect_80078F78, 1, (ObjectFunc) func_effect_80078EBC,             NULL,   300.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_394  */  {(void*) func_effect_80080D04, 1, (ObjectFunc) func_effect_80080ACC,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_395  */  {(void*) func_effect_80082F78, 1, (ObjectFunc) func_effect_80081C5C,             NULL,   300.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_396  */  {(void*) Andross_8018CF98, 1, (ObjectFunc) Andross_8018CAD4,             NULL,  2000.0f,  0, 1, 40, 2,   0.0f,  0 },
  /* OBJ_EFFECT_397  */  {(void*) Bolse_80191180, 1, (ObjectFunc) Bolse_80191054,             NULL,  2000.0f,  0, 1, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_398  */  {(void*) func_effect_8008092C, 1, (ObjectFunc) func_effect_8008040C,             NULL,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_399  */  {(void*) func_effect_80084194, 1, (ObjectFunc) func_effect_80083FA8,             NULL,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
};
// clang-format on
